/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  "gl_texture.h"



// łɓǂݍ܂Ă邩
bool
gl_textures::is_loaded(const char* name) const
{
	map<string, GLuint>::const_iterator  it = textures.find(string(name));
	if (it != textures.end()) {
		return true;		// łɓt@C̃eNX`ꍇ
	}
	return false;
}


//
GLuint
gl_textures::get_texture_name(const char* name)  const
{
	map<string, GLuint>::const_iterator  it = textures.find(string(name));
	if (it != textures.end()) {
		return it->second;	// łɓt@C̃eNX`ꍇ
	}
	return 0;
}


GLuint
gl_textures::add_texture(const char* name, int shrink_rate)
{
	GLuint  texname;
	// łɃ[hĂꍇ͂̒lԂ
	texname = get_texture_name(name);
	if (texname!=0)  { return texname; }
	// [hĂȂꍇ͐VɃ[h
	glGenTextures(1, &texname);
	// t@C̃[h
	image img;
	if (!load(name, img)) {
		// [hɎs
		glDeleteTextures(1, &texname);
		return 0;
	}
	// oCh
	glBindTexture(GL_TEXTURE_2D, texname);
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
	gl_set_texture_mipmaps(img, shrink_rate);
	img.free();
	if (glIsTexture(texname)==GL_TRUE) {
		// VeNX`𐶐ł
		pair<string, GLuint>  pr;
		pr.first = string(name);
		pr.second = texname;
		textures.insert(pr);
		return  texname;
	}
	// eNX`̐Ɏs
	return  0;
}


void
gl_textures::delete_texture(const char* name)
{
	GLuint  texname;
	// [hĂȂꍇ͉^[
	texname = get_texture_name(name);
	if (texname==0)		return;
	glDeleteTextures(1, &texname);
}

void
gl_textures::delete_texture_name(GLuint texname)
{
	if (texname == 0)  return;
	for (map<string, GLuint>::iterator  it = textures.begin(); it != textures.end(); it++) {
		if (it->second == texname) {
			glDeleteTextures(1, &it->second);
			textures.erase(it);
			return;
		}
	}
}

bool
gl_textures::load(const char* name, image& img)
{
	if (!img.load( dir.get_path(name)) )	{
		return  false;
	}
	return  true;
}
